diff --git a/contrib/ncurses/misc/terminfo.src b/contrib/ncurses/misc/terminfo.src
index c1fdeb8a875d..5d575b8eb454 100644
--- a/contrib/ncurses/misc/terminfo.src
+++ b/contrib/ncurses/misc/terminfo.src
@@ -3715,186 +3803,181 @@ iTerm2.app|iterm2|terminal emulator for Mac OS X,
 # color-bold entries do not include size information.
 
 # The '+' entries are building blocks
-xnuppc+basic|Darwin PowerPC Console basic capabilities,
-	am, bce, mir, xenl,
+xnuppc+basic|Darwin PowerPC console basic capabilities,
+	am, bce, mir, xenl, NQ,
 	it#8,
-	bold=\E[1m, clear=\E[H\E[J, cr=\r, csr=\E[%i%p1%d;%p2%dr,
-	cub=\E[%p1%dD, cub1=\E[D, cud=\E[%p1%dB, cud1=\E[B,
-	cuf=\E[%p1%dC, cuf1=\E[C, cup=\E[%i%p1%d;%p2%dH,
-	cuu=\E[%p1%dA, cuu1=\E[A, dsl=\E]2;\007, ed=\E[J, el=\E[K,
-	el1=\E[1K, home=\E[H, ht=^I, hts=\EH, ind=\n, kbs=^?,
-	kcub1=\EOD, kcud1=\EOB, kcuf1=\EOC, kcuu1=\EOA, rc=\E8,
-	rev=\E[7m, ri=\EM, rmam=\E[?7l, rmkx=\E[?1l\E>, rmso=\E[m,
-	rmul=\E[m, rs2=\E>\E[?3l\E[?4l\E[?5l\E[?7h\E[?8h,
-	sc=\E7,
+	bold=\E[1m, cr=\r, cuf1=\E[C, cup=\E[%i%p1%d;%p2%dH,
+	dsl=\E]2;\007, el1=\E[1K, home=\E[H, ht=^I, hts=\EH, ind=\n,
+	kbs=^?, kcub1=\EOD, kcud1=\EOB, kcuf1=\EOC, kcuu1=\EOA,
+	rev=\E[7m, ri=\EM, rmam=\E[?7l, rmkx=\E[?1l\E>,
+	rs2=\E>\E[?3l\E[?4l\E[?5l\E[?7h\E[?8h,
 	sgr=\E[0%?%p6%t;1%;%?%p2%t;4%;%?%p1%p3%|%t;7%;m,
-	sgr0=\E[m, smam=\E[?7h, smkx=\E[?1h\E=, smso=\E[7m,
-	smul=\E[4m, tbc=\E[3g, use=vt100+keypad,
+	sgr0=\E[m, smam=\E[?7h, smkx=\E[?1h\E=, tbc=\E[3g,
+	use=ansi+csr, use=ansi+erase, use=ansi+local,
+	use=ansi+sgrso, use=ansi+sgrul, use=vt100+keypad,
 
-xnuppc+c|Darwin PowerPC Console ANSI color support,
-	colors#8, ncv#32, pairs#64,
-	op=\E[37;40m, setab=\E[4%p1%dm, setaf=\E[3%p1%dm,
+xnuppc+c|Darwin PowerPC console ANSI color support,
+	ncv#32, use=klone+color,
 
-xnuppc+b|Darwin PowerPC Console color-bold support,
+xnuppc+b|Darwin PowerPC console color-bold support,
 	ncv#32,
 	bold=\E[35m,
 	sgr=\E[0%?%p6%t;35%;%?%p2%t;4%;%?%p1%p3%|%t;7%;m,
 	use=xnuppc+basic,
 
-xnuppc+f|Darwin PowerPC Console fancy color support,
+xnuppc+f|Darwin PowerPC console fancy color support,
 	ncv#35,
 	sgr=\E[0%?%p6%t;35%;%?%p2%t;36;4%;%?%p1%t;33;44%;%?%p3%t;7%;
 	    m,
 	smso=\E[33;44m, smul=\E[36;4m, use=xnuppc+b,
 
-xnuppc+f2|Darwin PowerPC Console alternate fancy color support,
+xnuppc+f2|Darwin PowerPC console alternate fancy color support,
 	ncv#35,
 	bold=\E[33m,
 	sgr=\E[0%?%p6%t;33%;%?%p2%t;34%;%?%p1%t;31;47%;%?%p3%t;7%;m,
 	smso=\E[31;47m, smul=\E[34m, use=xnuppc+basic,
 
 # Building blocks for specific screen sizes
-xnuppc+80x25|Darwin PowerPC Console 80x25 support (640x400 pixels),
+xnuppc+80x25|Darwin PowerPC console 80x25 support (640x400 pixels),
 	cols#80, lines#25,
 
-xnuppc+80x30|Darwin PowerPC Console 80x30 support (640x480 pixels),
+xnuppc+80x30|Darwin PowerPC console 80x30 support (640x480 pixels),
 	cols#80, lines#30,
 
-xnuppc+90x30|Darwin PowerPC Console 90x30 support (720x480 pixels),
+xnuppc+90x30|Darwin PowerPC console 90x30 support (720x480 pixels),
 	cols#90, lines#30,
 
-xnuppc+100x37|Darwin PowerPC Console 100x37 support (800x600 pixels),
+xnuppc+100x37|Darwin PowerPC console 100x37 support (800x600 pixels),
 	cols#100, lines#37,
 
-xnuppc+112x37|Darwin PowerPC Console 112x37 support (896x600 pixels),
+xnuppc+112x37|Darwin PowerPC console 112x37 support (896x600 pixels),
 	cols#112, lines#37,
 
-xnuppc+128x40|Darwin PowerPC Console 128x40 support (1024x640 pixels),
+xnuppc+128x40|Darwin PowerPC console 128x40 support (1024x640 pixels),
 	cols#128, lines#40,
 
-xnuppc+128x48|Darwin PowerPC Console 128x48 support (1024x768 pixels),
+xnuppc+128x48|Darwin PowerPC console 128x48 support (1024x768 pixels),
 	cols#128, lines#48,
 
-xnuppc+144x48|Darwin PowerPC Console 144x48 support (1152x768 pixels),
+xnuppc+144x48|Darwin PowerPC console 144x48 support (1152x768 pixels),
 	cols#144, lines#48,
 
-xnuppc+160x64|Darwin PowerPC Console 160x64 support (1280x1024 pixels),
+xnuppc+160x64|Darwin PowerPC console 160x64 support (1280x1024 pixels),
 	cols#160, lines#64,
 
-xnuppc+200x64|Darwin PowerPC Console 200x64 support (1600x1024 pixels),
+xnuppc+200x64|Darwin PowerPC console 200x64 support (1600x1024 pixels),
 	cols#200, lines#64,
 
-xnuppc+200x75|Darwin PowerPC Console 200x75 support (1600x1200 pixels),
+xnuppc+200x75|Darwin PowerPC console 200x75 support (1600x1200 pixels),
 	cols#200, lines#75,
 
-xnuppc+256x96|Darwin PowerPC Console 256x96 support (2048x1536 pixels),
+xnuppc+256x96|Darwin PowerPC console 256x96 support (2048x1536 pixels),
 	cols#0x100, lines#96,
 
 # These are different combinations of the building blocks
 
-xnuppc-m|darwin-m|Darwin PowerPC Console (monochrome),
+xnuppc-m|darwin-m|Darwin PowerPC console (monochrome),
 	use=xnuppc+basic,
 
-xnuppc|darwin|Darwin PowerPC Console (color),
+xnuppc|darwin|Darwin PowerPC console (color),
 	use=xnuppc+c, use=xnuppc+basic,
 
-xnuppc-m-b|darwin-m-b|Darwin PowerPC Console (monochrome w/color-bold),
+xnuppc-m-b|darwin-m-b|Darwin PowerPC console (monochrome w/color-bold),
 	use=xnuppc+b,
 
-xnuppc-b|darwin-b|Darwin PowerPC Console (color w/color-bold),
+xnuppc-b|darwin-b|Darwin PowerPC console (color w/color-bold),
 	use=xnuppc+b, use=xnuppc+c,
 
-xnuppc-m-f|darwin-m-f|Darwin PowerPC Console (fancy monochrome),
+xnuppc-m-f|darwin-m-f|Darwin PowerPC console (fancy monochrome),
 	use=xnuppc+f,
 
-xnuppc-f|darwin-f|Darwin PowerPC Console (fancy color),
+xnuppc-f|darwin-f|Darwin PowerPC console (fancy color),
 	use=xnuppc+f, use=xnuppc+c,
 
-xnuppc-m-f2|darwin-m-f2|Darwin PowerPC Console (alternate fancy monochrome),
+xnuppc-m-f2|darwin-m-f2|Darwin PowerPC console (alternate fancy monochrome),
 	use=xnuppc+f2,
 
-xnuppc-f2|darwin-f2|Darwin PowerPC Console (alternate fancy color),
+xnuppc-f2|darwin-f2|Darwin PowerPC console (alternate fancy color),
 	use=xnuppc+f2, use=xnuppc+c,
 
 # Combinations for specific screen sizes
-xnuppc-80x25-m|darwin-80x25-m|Darwin PowerPC Console (monochrome) 80x25,
+xnuppc-80x25-m|darwin-80x25-m|Darwin PowerPC console (monochrome) 80x25,
 	use=xnuppc+80x25, use=xnuppc+basic,
 
-xnuppc-80x25|darwin-80x25|Darwin PowerPC Console (color) 80x25,
+xnuppc-80x25|darwin-80x25|Darwin PowerPC console (color) 80x25,
 	use=xnuppc+c, use=xnuppc+80x25, use=xnuppc+basic,
 
-xnuppc-80x30-m|darwin-80x30-m|Darwin PowerPC Console (monochrome) 80x30,
+xnuppc-80x30-m|darwin-80x30-m|Darwin PowerPC console (monochrome) 80x30,
 	use=xnuppc+80x30, use=xnuppc+basic,
 
-xnuppc-80x30|darwin-80x30|Darwin PowerPC Console (color) 80x30,
+xnuppc-80x30|darwin-80x30|Darwin PowerPC console (color) 80x30,
 	use=xnuppc+c, use=xnuppc+80x30, use=xnuppc+basic,
 
-xnuppc-90x30-m|darwin-90x30-m|Darwin PowerPC Console (monochrome) 90x30,
+xnuppc-90x30-m|darwin-90x30-m|Darwin PowerPC console (monochrome) 90x30,
 	use=xnuppc+90x30, use=xnuppc+basic,
 
-xnuppc-90x30|darwin-90x30|Darwin PowerPC Console (color) 90x30,
+xnuppc-90x30|darwin-90x30|Darwin PowerPC console (color) 90x30,
 	use=xnuppc+c, use=xnuppc+90x30, use=xnuppc+basic,
 
-xnuppc-100x37-m|darwin-100x37-m|Darwin PowerPC Console (monochrome) 100x37,
+xnuppc-100x37-m|darwin-100x37-m|Darwin PowerPC console (monochrome) 100x37,
 	use=xnuppc+100x37, use=xnuppc+basic,
 
-xnuppc-100x37|darwin-100x37|Darwin PowerPC Console (color) 100x37,
+xnuppc-100x37|darwin-100x37|Darwin PowerPC console (color) 100x37,
 	use=xnuppc+c, use=xnuppc+100x37, use=xnuppc+basic,
 
-xnuppc-112x37-m|darwin-112x37-m|Darwin PowerPC Console (monochrome) 112x37,
+xnuppc-112x37-m|darwin-112x37-m|Darwin PowerPC console (monochrome) 112x37,
 	use=xnuppc+112x37, use=xnuppc+basic,
 
-xnuppc-112x37|darwin-112x37|Darwin PowerPC Console (color) 112x37,
+xnuppc-112x37|darwin-112x37|Darwin PowerPC console (color) 112x37,
 	use=xnuppc+c, use=xnuppc+112x37, use=xnuppc+basic,
 
-xnuppc-128x40-m|darwin-128x40-m|Darwin PowerPC Console (monochrome) 128x40,
+xnuppc-128x40-m|darwin-128x40-m|Darwin PowerPC console (monochrome) 128x40,
 	use=xnuppc+128x40, use=xnuppc+basic,
 
-xnuppc-128x40|darwin-128x40|Darwin PowerPC Console (color) 128x40,
+xnuppc-128x40|darwin-128x40|Darwin PowerPC console (color) 128x40,
 	use=xnuppc+c, use=xnuppc+128x40, use=xnuppc+basic,
 
-xnuppc-128x48-m|darwin-128x48-m|Darwin PowerPC Console (monochrome) 128x48,
+xnuppc-128x48-m|darwin-128x48-m|Darwin PowerPC console (monochrome) 128x48,
 	use=xnuppc+128x48, use=xnuppc+basic,
 
-xnuppc-128x48|darwin-128x48|Darwin PowerPC Console (color) 128x48,
+xnuppc-128x48|darwin-128x48|Darwin PowerPC console (color) 128x48,
 	use=xnuppc+c, use=xnuppc+128x48, use=xnuppc+basic,
 
-xnuppc-144x48-m|darwin-144x48-m|Darwin PowerPC Console (monochrome) 144x48,
+xnuppc-144x48-m|darwin-144x48-m|Darwin PowerPC console (monochrome) 144x48,
 	use=xnuppc+144x48, use=xnuppc+basic,
 
-xnuppc-144x48|darwin-144x48|Darwin PowerPC Console (color) 144x48,
+xnuppc-144x48|darwin-144x48|Darwin PowerPC console (color) 144x48,
 	use=xnuppc+c, use=xnuppc+144x48, use=xnuppc+basic,
 
-xnuppc-160x64-m|darwin-160x64-m|Darwin PowerPC Console (monochrome) 160x64,
+xnuppc-160x64-m|darwin-160x64-m|Darwin PowerPC console (monochrome) 160x64,
 	use=xnuppc+160x64, use=xnuppc+basic,
 
-xnuppc-160x64|darwin-160x64|Darwin PowerPC Console (color) 160x64,
+xnuppc-160x64|darwin-160x64|Darwin PowerPC console (color) 160x64,
 	use=xnuppc+c, use=xnuppc+160x64, use=xnuppc+basic,
 
-xnuppc-200x64-m|darwin-200x64-m|Darwin PowerPC Console (monochrome) 200x64,
+xnuppc-200x64-m|darwin-200x64-m|Darwin PowerPC console (monochrome) 200x64,
 	use=xnuppc+200x64, use=xnuppc+basic,
 
-xnuppc-200x64|darwin-200x64|Darwin PowerPC Console (color) 200x64,
+xnuppc-200x64|darwin-200x64|Darwin PowerPC console (color) 200x64,
 	use=xnuppc+c, use=xnuppc+200x64, use=xnuppc+basic,
 
-xnuppc-200x75-m|darwin-200x75-m|Darwin PowerPC Console (monochrome) 200x75,
+xnuppc-200x75-m|darwin-200x75-m|Darwin PowerPC console (monochrome) 200x75,
 	use=xnuppc+200x75, use=xnuppc+basic,
 
-xnuppc-200x75|darwin-200x75|Darwin PowerPC Console (color) 200x75,
+xnuppc-200x75|darwin-200x75|Darwin PowerPC console (color) 200x75,
 	use=xnuppc+c, use=xnuppc+200x75, use=xnuppc+basic,
 
-xnuppc-256x96-m|darwin-256x96-m|Darwin PowerPC Console (monochrome) 256x96,
+xnuppc-256x96-m|darwin-256x96-m|Darwin PowerPC console (monochrome) 256x96,
 	use=xnuppc+256x96, use=xnuppc+basic,
 
-xnuppc-256x96|darwin-256x96|Darwin PowerPC Console (color) 256x96,
+xnuppc-256x96|darwin-256x96|Darwin PowerPC console (color) 256x96,
 	use=xnuppc+c, use=xnuppc+256x96, use=xnuppc+basic,
 
 ######## DOS/WINDOWS
 # CRT is shareware.  It implements some xterm features, including mouse.
 crt|crt-vt220|CRT 2.3 emulating VT220,
-	bce, msgr,
-	ncv@,
-	hts=\EH, use=vt100+enq, use=vt220-base, use=ecma+color,
+	bce,
+	ncv@, use=vt100+enq, use=vt220-base, use=ecma+color,
 
 # SecureCRT 8.7.3.2279
 # 8.7.3 was released 2020/08/11
@@ -3955,7 +4038,7 @@ crt|crt-vt220|CRT 2.3 emulating VT220,
 #	resize.pl gets no reply, resize.sh needs fix for no reply.
 scrt|securecrt|SecureCRT emulating xterm-256color,
 	bce@, km@, npc,
-	bel@, cvvis@, kcbt=\E[Z, kent=\EOM, use=vt220+pcedit,
+	bel@, cvvis@, kcbt=\E[Z, use=vt220+pcedit,
 	use=xterm+256setaf, use=ecma+index, use=ansi+rep,
 	use=xterm+keypad, use=xterm+pcfkeys, use=xterm-basic,
 
@@ -3969,7 +4052,7 @@ scrt|securecrt|SecureCRT emulating xterm-256color,
 #	Double-size characters
 #	Xterm extensions for mouse support
 #	Emulates VT52, VT100, VT220, VT320, ansi, xterm, qnx, scoansi,
-#	ANSIBBS, WYSE60, Televideo 950.
+#	ANSIBBS, WYSE60, TeleVideo 950.
 #
 # Default:
 #	TERM=xterm
@@ -4005,15 +4088,23 @@ scrt|securecrt|SecureCRT emulating xterm-256color,
 #	supports 256-colors, including changing palette (ncurses menu d works)
 #	supports UTF-8, but honors VT100 line-drawing
 absolute|Absolute Telnet emulating xterm,
-	kcbt=\E[Z, use=ecma+index, use=ansi+rep,
+	kcbt=\E[Z, use=ecma+index, use=linux+kbs, use=ansi+rep,
 	use=vt220+pcedit, use=xterm+keypad, use=xterm+app,
 	use=xterm+pcf0, use=xterm+256color, use=xterm+x11mouse,
 	use=xterm-basic,
 
 #### PuTTY
-# PuTTY 0.74 (27 June 2020)
 # http://www.chiark.greenend.org.uk/~sgtatham/putty/
 #
+# PuTTY 0.78 (September 2020, tested 12 August 2023)
+# Testing with tack:
+#	implements cross-out text (shortly after 0.74)
+#	restore kLFT as kLFT5, etc. (mentioned in October 2021)
+#	does not support direct-colors (mentioned in July 2021)
+#
+# PuTTY 0.74 (27 June 2020)
+#	(unchanged)
+#
 # PuTTY 0.73 (September 2019)
 # Testing with tack:
 #	does not implement italics
@@ -4037,7 +4128,7 @@ absolute|Absolute Telnet emulating xterm,
 #
 # PuTTY 0.51 (14 December 2000)
 #
-# This emulates vt100 + vt52 (plus a few vt220 features:  ech, SRM, DECTCEM, as
+# This emulates VT100 + VT52 (plus a few VT220 features:  ech, SRM, DECTCEM, as
 # well as SCO and Atari, color palettes from Linux console).  Reading the code,
 # it is intended to be VT102 plus selected features.  By default, it sets $TERM
 # to xterm, which is incorrect, since several features are misimplemented:
@@ -4058,48 +4149,52 @@ absolute|Absolute Telnet emulating xterm,
 #	http://stackoverflow.com/questions/24613237/terminal-retains-bg-color-after-closing-vim-using-color-scheme-and-putty-256co/37869114#37869114
 putty|PuTTY terminal emulator,
 	am, bce, bw, ccc, mir, msgr, xenl, xon, XT,
-	colors#8, it#8, ncv#22, pairs#64, U8#1,
+	it#8, ncv#22, U8#1,
 	acsc=``aaffggjjkkllmmnnooppqqrrssttuuvvwwxxyyzz{{||}}~~,
-	bel=^G, blink=\E[5m, bold=\E[1m, clear=\E[H\E[J, cr=\r,
-	csr=\E[%i%p1%d;%p2%dr, cub=\E[%p1%dD, cub1=^H,
-	cud=\E[%p1%dB, cud1=\ED, cuf=\E[%p1%dC, cuf1=\E[C,
-	cup=\E[%i%p1%d;%p2%dH, cuu=\E[%p1%dA, cuu1=\EM,
-	dch=\E[%p1%dP, dch1=\E[P,
+	bel=^G, cr=\r, cub1=^H, cud1=\ED, cup=\E[%i%p1%d;%p2%dH,
+	cuu1=\EM, dch=\E[%p1%dP, dch1=\E[P,
 	dispc=%?%p1%{8}%=%t\E%%G\342\227\230\E%%@%e%p1%{10}%=%t\E%%G
 	      \342\227\231\E%%@%e%p1%{12}%=%t\E%%G\342\231\0\E%%@%e
 	      %p1%{13}%=%t\E%%G\342\231\252\E%%@%e%p1%{14}%=%t\E%%G
 	      \342\231\253\E%%@%e%p1%{15}%=%t\E%%G\342\230\274\E%%@
 	      %e%p1%{27}%=%t\E%%G\342\206\220\E%%@%e%p1%{155}%=%t\E
 	      %%G\340\202\242\E%%@%e%p1%c%;,
-	dl=\E[%p1%dM, dl1=\E[M, ech=\E[%p1%dX, ed=\E[J, el=\E[K,
-	el1=\E[1K, enacs=\E(B\E)0, flash=\E[?5h$<100/>\E[?5l,
-	home=\E[H, hpa=\E[%i%p1%dG, il=\E[%p1%dL, il1=\E[L, ind=\n,
+	ech=\E[%p1%dX, el1=\E[1K, enacs=\E(B\E)0,
+	flash=\E[?5h$<100/>\E[?5l, home=\E[H, hpa=\E[%i%p1%dG,
+	ind=\n,
 	initc=\E]P%p1%x%p2%{255}%*%{1000}%/%02x%p3%{255}%*%{1000}%/
 	      %02x%p4%{255}%*%{1000}%/%02x,
 	is2=\E7\E[r\E[m\E[?7h\E[?1;4;6l\E[4l\E8\E>\E]R,
-	kbs=^?, kcbt=\E[Z, kcub1=\EOD, kcud1=\EOB, kcuf1=\EOC,
-	kcuu1=\EOA, kind=\E[B, kri=\E[A, kspd=^Z, nel=\r\n, oc=\E]R,
-	op=\E[39;49m, rc=\E8, rev=\E[7m, ri=\EM, rmacs=^O,
-	rmam=\E[?7l, rmcup=\E[2J\E[?47l, rmir=\E[4l,
-	rmkx=\E[?1l\E>, rmpch=\E[10m, rmso=\E[27m, rmul=\E[24m,
+	kbs=^?, kcbt=\E[Z, khome=\E[1~, kind=\E[B, kri=\E[A, kspd=^Z,
+	nel=\r\n, oc=\E]R, op=\E[39;49m, ri=\EM, rmacs=^O,
+	rmam=\E[?7l, rmir=\E[4l, rmkx=\E[?1l\E>, rmso=\E[27m,
+	rmul=\E[24m,
 	rs2=\E<\E["p\E[50;6"p\Ec\E[?3l\E]R\E[?1000l,
-	s0ds=\E[10m, s1ds=\E[11m, s2ds=\E[12m, sc=\E7,
-	setab=\E[4%p1%dm, setaf=\E[3%p1%dm,
+	s0ds=\E[10m, s1ds=\E[11m, s2ds=\E[12m,
 	sgr=\E[0%?%p1%p6%|%t;1%;%?%p2%t;4%;%?%p1%p3%|%t;7%;%?%p4%t;5
 	    %;m%?%p9%t\016%e\017%;,
-	sgr0=\E[m\017, smacs=^N, smam=\E[?7h, smcup=\E[?47h,
-	smir=\E[4h, smkx=\E[?1h\E=, smpch=\E[11m, smso=\E[7m,
-	smul=\E[4m, vpa=\E[%i%p1%dd, E3=\E[3J, use=vt220+pcedit,
-	use=ansi+tabs, use=ansi+rep, use=ecma+index,
-	use=xterm+sm+1006, use=putty+fnkeys, use=vt102+enq,
+	sgr0=\E[m\017, smacs=^N, smam=\E[?7h, smir=\E[4h,
+	smkx=\E[?1h\E=, vpa=\E[%i%p1%dd, E3=\E[3J,
+	use=ansi+apparrows, use=ansi+csr, use=ansi+erase,
+	use=ansi+idl, use=ansi+local, use=ansi+tabs,
+	use=ansi+rep, use=bracketed+paste, use=ecma+index,
+	use=ecma+strikeout, use=klone+color, use=klone+sgr,
+	use=putty+cursor, use=putty+fnkeys, use=vt220+pcedit,
+	use=xterm+alt1049, use=vt102+enq, use=xterm+sm+1006,
 	use=xterm+sl, use=vt100+fnkeys, use=putty+keypad,
 	use=vt220+cvis,
+
+# older versions (e.g., before 0.71) of PuTTY used a shift-modifier to toggle
+# between normal- and application-mode for the cursor-keys.  That was dropped,
+# and a few years later (after 0.74) restored as the control-modifier.
+putty+cursor|PuTTY modified cursor-keys,
+	kDN5=\E[B, kLFT5=\E[D, kRIT5=\E[C, kUP5=\E[A,
 putty+keypad|PuTTY numeric keypad,
 	kp1=\EOq, kp2=\EOr, kp3=\EOs, kp4=\EOt, kp5=\EOu, kp6=\EOv,
 	kp7=\EOw, kp8=\EOx, kp9=\EOy, kpADD=\EOl, kpDIV=\EOQ,
 	kpDOT=\EOn, kpMUL=\EOR, kpNUM=\EOP, kpSUB=\EOS, kpZRO=\EOp,
 
-vt100-putty|Reset PuTTY to pure vt100,
+vt100-putty|Reset PuTTY to pure VT100,
 	rs2=\E<\E["p\Ec\E[?3l\E]R\E[40"p\E[61"p\E[50;1;2"p,
 	use=vt100,
 putty-256color|PuTTY 0.58 with xterm 256-colors,
@@ -4209,20 +4304,19 @@ mintty|Cygwin Terminal,
 	setal=\E[5%p1%dm, use=xterm+256color,
 	use=mintty+common,
 mintty-direct|Cygwin Terminal direct-color,
-	setal=\E[%?%p1%{8}%<%t5%p1%d%e58\:2\:\:%p1%{65536}%/%d\:%p1
-	      %{256}%/%{255}%&%d\:%p1%{255}%&%d%;m,
-	use=xterm+direct, use=mintty+common,
+	use=kitty+setal, use=xterm+direct, use=mintty+common,
 mintty+common|shared capabilities for mintty,
 	km@, npc,
 	kcbt=\E[Z, kent=\EOM, rmm@, rmpch=\E[10m,
 	rs1=\Ec\E]104\007, rshm=\E[22m, rsubm=\E[75m,
-	rsupm=\E[75m, smm@, smpch=\E[11m, sshm=\E[1\:2m,
+	rsupm=\E[75m, smm@, smpch=\E[11m, sshm=\E[1:2m,
 	ssubm=\E[74m, ssupm=\E[73m, Rmol=\E[55m, Smol=\E[53m,
-	Smulx=\E[4\:%p1%dm, blink2=\E[6m, norm=\E[22m,
-	opaq=\E[28m, smul2=\E[21m, use=ansi+rep,
+	Smulx=\E[4:%p1%dm, blink2=\E[6m, norm=\E[22m,
+	opaq=\E[28m, smul2=\E[21m, use=linux+kbs, use=ansi+rep,
 	use=ecma+strikeout, use=ecma+index, use=vt420+lrmm,
-	use=xterm+sm+1006, use=xterm+pcfkeys, use=xterm+tmux,
-	use=ecma+italics, use=xterm-basic,
+	use=xterm+focus, use=xterm+sm+1006, use=xterm+pcfkeys,
+	use=xterm+tmux, use=ecma+italics, use=xterm-basic,
+	use=bracketed+paste, use=report+version,
 # 2019-06-09: These capabilities are commented-out for compatibility with
 # existing releases 5.9-6.1, and may be considered for inclusion after the
 # release of ncurses 6.2:
@@ -4257,14 +4351,14 @@ mintty+common|shared capabilities for mintty,
 #	- Japanese and Russian character sets.
 #
 # The program does not come with terminfo or termcap entries.  However, the
-# emulation (testing with vttest and ncurses) is reasonably close to vt100 (no
-# vt52 or doublesize character support; blinking is done with color).  Besides
+# emulation (testing with vttest and ncurses) is reasonably close to VT100 (no
+# VT52 or doublesize character support; blinking is done with color).  Besides
 # the HPA, VPA extensions it also implements CPL and CNL.
 #
 # All of the function keys can be remapped.  This description shows the default
-# mapping, as installed.  Both vt100 PF1-PF4 keys and quasi-vt220 F1-F4 keys
+# mapping, as installed.  Both VT100 PF1-PF4 keys and quasi-vt220 F1-F4 keys
 # are supported.  F13-F20 are obtained by shifting F3-F10.  The editing keypad
-# is laid out like vt220, rather than the face codes on the PC keyboard, i.e,
+# is laid out like VT220, rather than the face codes on the PC keyboard, i.e,
 #	kfnd	Insert
 #	kslt	Delete
 #	kich1	Home
@@ -4282,7 +4376,7 @@ mintty+common|shared capabilities for mintty,
 # retrieving the window title, and for setting the window size (i.e., using
 # "resize -s"), though it does not pass SIGWINCH to the application if the
 # user resizes the window with the mouse.
-teraterm2.3|Tera Term Pro,
+teraterm2.3|Tera Term Pro 2.3,
 	km,
 	ncv#43, vt@,
 	acsc=+\020\,\021-\030.^Y0\333`\004a\261f\370g\361h\260i
@@ -4290,33 +4384,32 @@ teraterm2.3|Tera Term Pro,
 	     \264v\301w\302x\263y\363z\362{\343|\330}\234~\376,
 	blink=\E[5m, bold=\E[1m, clear=\E[H\E[J, cuf1=\E[C,
 	cup=\E[%i%p1%d;%p2%dH, cuu1=\E[A, dch=\E[%p1%dP,
-	dch1=\E[P, dl=\E[%p1%dM, dl1=\E[M, ech=\E[%p1%dX, ed=\E[J,
-	el=\E[K, el1=\E[1K, flash=\E[?5h$<200/>\E[?5l,
-	hpa=\E[%i%p1%dG, il=\E[%p1%dL, il1=\E[L, kf1=\E[11~,
+	dch1=\E[P, ech=\E[%p1%dX, ed=\E[J, el=\E[K, el1=\E[1K,
+	flash=\E[?5h$<200/>\E[?5l, hpa=\E[%i%p1%dG, kf1=\E[11~,
 	kf10=\E[21~, kf11=\E[23~, kf12=\E[24~, kf13=\E[25~,
 	kf14=\E[26~, kf15=\E[28~, kf16=\E[29~, kf17=\E[31~,
 	kf18=\E[32~, kf19=\E[33~, kf2=\E[12~, kf20=\E[34~,
 	kf3=\E[13~, kf4=\E[14~, kf5=\E[15~, kf6=\E[17~, kf7=\E[18~,
 	kf8=\E[19~, kf9=\E[20~, op=\E[100m, rev=\E[7m, ri=\EM,
 	rmso=\E[27m, rmul=\E[24m, sgr0=\E[0m\017, smso=\E[7m,
-	smul=\E[4m, vpa=\E[%i%p1%dd, use=vt220+vtedit,
-	use=vt100+enq, use=klone+color, use=vt100,
-	use=vt220+cvis,
+	smul=\E[4m, vpa=\E[%i%p1%dd, use=ansi+idl,
+	use=vt220+vtedit, use=vt100+enq, use=klone+color,
+	use=vt100, use=vt220+cvis,
 
-# Version 4.59 has regular vt100 line-drawing (so it is no longer necessary
+# Version 4.59 has regular VT100 line-drawing (so it is no longer necessary
 # to choose a Windows OEM font).
 #
 # Testing with tack:
 #	- it does not have xenl (suppress that)
 #	- underline seems to work with color (modify ncv).
 # Testing with vttest:
-#	- wrapping differs from vt100 (menu 1).
+#	- wrapping differs from VT100 (menu 1).
 #	- it recognizes xterm's X10 and normal mouse tracking, but none of the
 #	  other flavors.
 #	- it recognizes the dtterm window controls for reporting size in
 #	  characters and pixels.
 #	- it passes SIGWINCH.
-teraterm4.59|Tera Term Pro,
+teraterm4.59|Tera Term Pro 4.59,
 	bce, xenl@,
 	ncv#41,
 	acsc=``aaffggjjkkllmmnnooppqqrrssttuuvvwwxxyyzz{{||}}~~,
@@ -4346,7 +4439,7 @@ teraterm4.59|Tera Term Pro,
 #	+ recognizes xterm's original direct-colors sequences, but result is
 #	  poor.
 #	+ no UTF-8 apparent when UTF-8 is set, with font Lucida Control
-teraterm4.97|Tera Term Pro,
+teraterm4.97|Tera Term Pro 4.97,
 	XT, use=ecma+color, use=xterm+sm+1006, use=teraterm4.59,
 teraterm-256color|TeraTerm with xterm 256-colors,
 	use=xterm+256setaf, use=teraterm,
@@ -4362,10 +4455,10 @@ teraterm|Tera Term,
 # Other notes:
 # a) Fails tack's cup (cursor-addressing) test, though cup works well enough
 #    for casual (occasional) use.  Also fails several of the vttest screens,
-#    but that is not unusual for vt100 "emulators".
-# b) Does not implement vt100 keypad
-# c) Recognizes a subset of vt52 controls.
-ms-vt100|MS telnet imitating dec vt100,
+#    but that is not unusual for VT100 "emulators".
+# b) Does not implement VT100 keypad
+# c) Recognizes a subset of VT52 controls.
+ms-vt100|MS telnet imitating DEC VT100,
 	lines#25,
 	acsc=+\020\,\021-\030.^Y0\333`\004a\261f\370g\361h\260i
 	     \316j\331k\277l\332m\300n\305o~p\304q\304r\304s_t\303u
@@ -4380,7 +4473,7 @@ ms-vt100|MS telnet imitating dec vt100,
 # a) This version has no function keys or numeric keypad.  Unlike the older
 #    version, the numeric keypad is entirely ignored.
 # b) The program sets $TERM to "ansi", which of course is inaccurate.
-ms-vt100-color|vtnt|windows 2000 ansi (sic),
+ms-vt100-color|vtnt|windows 2000 ANSI (sic),
 	bce,
 	dch=\E[%p1%dP, ich=\E[%p1%d@, use=ecma+color,
 	use=ms-vt100,
@@ -4400,7 +4493,7 @@ ms-vt100-color|vtnt|windows 2000 ansi (sic),
 #	Shift	\E^S
 #	Alt	\E^A,
 #	Ctrl	\E^C,
-ms-vt100+|vt100+|windows XP vt100+ (sic),
+ms-vt100+|vt100+|windows XP VT100+ (sic),
 	kdch1=\E-, kend=\Ek, kf1=\E1, kf10=\E0, kf11=\E!, kf12=\E@,
 	kf13=\E\023\E1, kf14=\E\023\E2, kf15=\E\023\E3,
 	kf16=\E\023\E4, kf17=\E\023\E5, kf18=\E\023\E6,
@@ -4417,22 +4510,151 @@ ms-vt100+|vt100+|windows XP vt100+ (sic),
 	kf6=\E6, kf7=\E7, kf8=\E8, kf9=\E9, khome=\Eh, kich1=\E+,
 	knp=\E/, kpp=\E?, use=ms-vt100-color,
 
-ms-vt-utf8|vt-utf8|UTF-8 flavor of vt100+,
+ms-vt-utf8|vt-utf8|UTF-8 flavor of VT100+,
 	use=ms-vt100+,
 
+# VT-UTF-8 and VT100+ Protocols
+# https://learn.microsoft.com/en-us/openspecs/windows_protocols/ms-vuvp/969416c0-ccd6-4a75-a9b3-597d7713845b
+#
+# This Microsoft "protocol" adapted the aixterm 16-color feature from xterm's
+# documentation in 2015, as seen in successive revisions:
+#
+# 2013/07/22 has 8 colors
+# 2015/10/16 has 16 colors using SGR 90-97, 100-107 as well as SGR 24 and 27,
+#            adds "informative" reference to xterm's ctlseqs
+#
+# The cnorm/civis definitions added in 2015 are unrelated to any standard.
+ms-vt100-16color|VT-UTF-8 and VT100+,
+	civis=\E[?h, cnorm=\E[?l, rmso=\E[27m, rmul=\E[24m,
+	use=ibm+16color, use=ms-vt100+,
+
+# Based on
+# https://docs.microsoft.com/en-us/windows/console/console-virtual-terminal-sequences
+# We use this scheme to map function keys
+#       terminfo        modifier        code    keys
+#       kf13-kf24       shift           2       F1 to F12
+#       kf25-kf36       alt             3       F1 to F12
+#       kf37-kf48       control         4       F1 to F12
+#       kf49-kf60       ctrl-alt        7       F1 to F12
+#
+# Unclear: smam and rmam implemented?
+# Unclear: rmkx, smkx, rmir, smir - irrelevant?
+#
+# TD:
+# +	According to tack, tbc and cbt fail.
+# +	The line-drawing (acsc) does not work in telnet or ssh.  I added the
+#	U8 extension to tell ncurses to use UTF-8 for line-drawing (when the
+#	locale uses UTF-8).  That won't work for telnet (which uses ASCII),
+#	but seems to work for OpenSSH's ssh.  I set the codepage to 65001,
+#	of course.
+# +	Function keys... do not work consistently in telnet and ssh.  With
+#	telnet, kf1-kf4 are \EOP to \EOS, and kf5-kf12 match the terminfo.
+#	But with ssh, it's entirely different (reminds me of rxvt).
+winconsole|Windows 10 new console,
+	am, km, mir, msgr, xenl,
+	ncv@, U8#1,
+	acsc=++\,\,--..00``aaffgghhiijjkkllmmnnooppqqrrssttuuvvwwxxy
+	     yzz~~,
+	bel=^G, blink@, cr=\r, ech=\E[%p1%dX, el1=\E[0K, ich1@, ind=\n,
+	invis@, is1=\E[!p, kf13=\E[11;2~, kf14=\E[12;2~,
+	kf15=\E[13;2~, kf16=\E[14;2~, kf17=\E[15;2~,
+	kf18=\E[17;2~, kf19=\E[18;2~, kf20=\E[19;2~,
+	kf21=\E[20;2~, kf22=\E[21;2~, kf23=\E[24;2~,
+	kf24=\E[25;2~, kf25=\E[11;3~, kf26=\E[12;3~,
+	kf27=\E[13;3~, kf28=\E[14;3~, kf29=\E[15;3~,
+	kf30=\E[17;3~, kf31=\E[18;3~, kf32=\E[19;3~,
+	kf33=\E[20;3~, kf34=\E[21;3~, kf35=\E[24;3~,
+	kf36=\E[25;3~, kf37=\E[11;4~, kf38=\E[12;4~,
+	kf39=\E[13;4~, kf40=\E[14;4~, kf41=\E[15;4~,
+	kf42=\E[17;4~, kf43=\E[18;4~, kf44=\E[19;4~,
+	kf45=\E[20;4~, kf46=\E[21;4~, kf47=\E[24;4~,
+	kf48=\E[25;4~, kf49=\E[11;7~, kf50=\E[12;7~,
+	kf51=\E[13;7~, kf52=\E[14;7~, kf53=\E[15;7~,
+	kf54=\E[17;7~, kf55=\E[18;7~, kf56=\E[19;7~,
+	kf57=\E[20;7~, kf58=\E[21;7~, kf59=\E[24;7~,
+	kf60=\E[25;7~, khome=\E[1~, nel=\r\n, ri=\E[T, rmacs=\E(B,
+	rmir@, rmpch@, rs1=\E[!p,
+	sgr=\E[0%?%p1%p6%|%t;1%;%?%p2%t;4%;%?%p1%p3%|%t;7%;m%?%p9%t
+	    \E(0%e\E(B%;,
+	sgr0=\E[0m\E(B, smacs=\E(0, smir@, smpch@, use=ansi+arrows,
+	use=ansi+csr, use=ansi+cup, use=ansi+erase, use=ansi+idc,
+	use=ansi+idl, use=ecma+index, use=ansi+inittabs,
+	use=ansi+local, use=ecma+sgr, use=ecma+color,
+	use=vt220+cvis, use=vt220+pcedit, use=xterm+nopcfkeys,
+
 # Windows Terminal (Preview)
-# Windows 10 1903
-# Version 0.2.1831.0
 # https://github.com/microsoft/terminal
 #
-# The task manager shows this as "OpenConsole.exe", which differs
-# from the "Windows Command Processor" used for the command-prompt.
+# Windows 10 22H2 (also Windows 11)
+# Version 1.16.10261.0
 #
-# The settings dialog does not work (unless the end user expects to open
-# profiles.json in Visual Studio).  There is no documentation, of course.
+# - Windows Terminal #1553: "Feature Request:  Mouse/Touch/Pointer Bindings
+#   (like middle-click paste, right-click context menu, etc.)", compare to
+#   https://learn.microsoft.com/en-us/windows/console/mouse-event-record-str
+#   This appears to be related to a problem with its implementation of the
+#   Console API; the mouse does not work in a "Command Window" (e.g., as used
+#   in the ncurses MinGW driver), although escape sequences work.
 #
-# Testing via an ssh connection, using openssh:
-# - the program sets TERM to cygwin if the tab is set to PowerShell,
+# Windows 10 21H1
+# Version 1.9.1942.0
+#
+# This has longstanding issues with CR/LF mapping, e.g.,
+# - first reported by Juergen Pfeifer August 13, 2020, with workaround
+# - Windows Terminal #8303 "Updates to ms-terminal terminal type in terminfo to
+#   1.4 from 0.2"
+# - Windows Terminal #6733 "Midnight Commander (mc) output is screwed when
+#   using the 'ms-terminal' as $TERM"
+#
+# still seen in testing during May-July 2021.  As a workaround, this terminal
+# description sets cud1 to an escape sequence rather than just \r.
+#
+# Using TERM=xterm-256color shows a number of problems.
+# A few are seen only in the WSL2 environment.
+#
+# tack:
+# - flash does not work.
+# - video attribute blink does not work.
+# - video attribute invis does not work in WSL2.
+# - italics sitm/ritm do not work in WSL2.
+# - crossed-out smxx/rmxx do not work in WSL2.
+# - reloading colors via initp interchanges red/blue.
+# - does not implement OSC 104, which is used for resetting colors in xterm.
+# - does not support numeric keypad application mode.
+# - control-modifier (without alt/shift) does not work for special keys.
+# - meta-key sends escape character rather than acting as a meta key.
+#
+# vttest:
+# - identifies itself as a VT100.
+# - cursor movement (menu 1) does not work properly, e.g., for wrapping.
+# - does not support 8-bit controls.
+# - does not support VT420 rectangles.
+# - does not support VT420 left/right margins.
+# - ECMA-48 cursor-movement works.
+# - does not support X10 mouse, or mouse highlight tracking.
+# - SGR mouse mode 1006 works.
+# - any-event mouse mode shows no focus-in/focus-out events.
+# - alternate screen 47/48 modes do not work, nor do 1047/1048.
+# - alternate screen 1049 mode works.
+# - none of the window report/modify operations work.
+# - none of the DECRPM/DECRQM reporting operations work.
+#
+# xterm:
+# - 256colors2.pl -r, -i and -q options work.
+# - dynamic colors do not work.
+# - paste64.pl does not work, i.e., bracketed-paste.
+# - tcapquery.pl does not work.
+#
+# Windows 10 1903
+# Version 0.2.1831.0
+#
+# The task manager shows this as "OpenConsole.exe", which differs
+# from the "Windows Command Processor" used for the command-prompt.
+#
+# The settings dialog does not work (unless the end user expects to open
+# profiles.json in Visual Studio).  There is no documentation, of course.
+#
+# Testing via an ssh connection, using openssh:
+# - the program sets TERM to cygwin if the tab is set to PowerShell,
 #   and to xterm-256color if "Legacy".  However, in the latter, more tests
 #   fail in vttest, which does not pay attention to TERM.
 # vttest:
@@ -4462,9 +4684,11 @@ ms-vt-utf8|vt-utf8|UTF-8 flavor of vt100+,
 # - does not recognize either xterm+direct or xterm+indirect escapes.
 ms-terminal|Windows10 terminal,
 	npc,
-	rmkx=\E[?1l, rmm@, smkx=\E[?1h, smm@, use=xterm+256setaf,
-	use=xterm+pcfkeys, use=ansi+rep, use=ecma+index,
-	use=ecma+italics, use=xterm-basic,
+	cud1=\E[B, kcbt=\E[Z, rmkx=\E[?1l, rmm@, smkx=\E[?1h, smm@,
+	Cr@, Ms@, use=linux+kbs, use=xterm+256color,
+	use=xterm+pcfkeys, use=ansi+rep, use=xterm+sm+1006,
+	use=ecma+index, use=ecma+italics, use=ecma+strikeout,
+	use=xterm-basic, use=xterm+tmux,
 
 #### Visual Studio
 # Visual Studio Code 1.45.0 uses xterm.js 12.8.1 (see https://xtermjs.org/).
@@ -4513,9 +4737,10 @@ ms-terminal|Windows10 terminal,
 # - color-palette cannot be changed
 vscode|xterm.js|Visual Studio Code terminal using xterm.js,
 	npc,
-	kcbt=\E[Z, rmkx=\E[?1l, smkx=\E[?1h, use=xterm+256setaf,
-	use=ecma+index, use=xterm+sm+1006, use=xterm+pcfkeys,
-	use=ecma+italics, use=xterm-basic,
+	kcbt=\E[Z, rmkx=\E[?1l, smkx=\E[?1h, use=linux+kbs,
+	use=xterm+256setaf, use=ecma+index, use=xterm+focus,
+	use=xterm+sm+1006, use=xterm+pcfkeys, use=ecma+italics,
+	use=xterm-basic, use=bracketed+paste,
 vscode-direct|Visual Studio Code with direct-colors,
 	use=xterm+indirect, use=vscode,
 
